
*MEDCURVE macro for SAS;
*Written by Andrew F. Hayes in 2010;
*Haskayne School of Business;
*University of Calgary;
*andrew.hayes@ucalgary.ca;

%macro medcurve (data=,y=,x=,m=,aform=1,bform=1,cpform=1,boot=0,xval=9999,conf=95,percent=0,save=0);
options pagesize = 10000;
proc iml;
use &data;
read all var{&y &x &m} into dd;
nms = {&y &x &m};
xx=(dd = .);xx=xx[,+];
j=1;do i = 1 to nrow(dd);if xx[i,1]=0 then;do;dd[j,]=dd[i,];j=j+1;end;end;
dd=dd[1:j-1,];
nms = nms`;
n=nrow(dd);
y1=dd[,1];m1=dd[,3];mo1=m1;ncov=ncol(dd)-3;x1=dd[,2];xest1=x1;xv=&xval;con=j(n,1,1);
if (ncov > 0) then;do;cov1=dd[,4:ncol(dd)];cov1mns=cov1[+,]/n;print cov1mns;end;
simple=0;zerr=0;nerr=0;lnerr=0;lnerr2=0;dindep=0;dmed=0;ddv=0;xmax = max(x1);xmin=min(x1);
aform=&aform;cpform=&cpform;bform=&bform;
tmp=(x1=0);zxcheck=tmp[+];
tmp=(mo1=0);zmcheck=tmp[+];
tmp=(x1<0);nxcheck=tmp[+];
tmp=(mo1<0);nmcheck=tmp[+];
tmp=ncol(design(x1));
if (tmp = 2) then;do;dindep=1;aform=1;cpform=1;zxcheck=0;nxcheck=0;xv=xmin;end;
tmp2=ncol(design(m1));if(tmp2 = 2) then;do;dmed=1;end;
tmp3=ncol(design(y1));if(tmp3 = 2) then;do;ddv=1;end;
conf = &conf;
p0 = -0.322232431088;
p1 = -1;
p2 = -0.342242088547;
p3 = -0.0204231210245;
p4 = -.0000453642210148;
q0 = 0.0993484626060;
q1 = 0.588581570495;
q2 = 0.531103462366;
q3 = 0.103537752850;
q4 = 0.0038560700634;
if (conf < 50 | conf > 99) then;do;conf = 95;end;
p=0.5*(1-(conf/100));y5=sqrt(-2*log(p));
xp2=y5+((((y5*p4+p3)*y5+p2)*y5+p1)*y5+p0)/((((y5*q4+q3)*y5+q2)*y5+q1)*y5+q0);xp=xp2;
btn = 1;if (&boot > 999) then;do;btn = (floor(&boot/1000)*1000)+1;end;
if (zxcheck > 0 & (aform = 2 | aform = 5 | cpform = 2 | cpform = 5)) then;do;zerr=1;end;
if (zmcheck > 0 & (bform = 2 | bform = 5)) then;do;zerr = 1;end;
if (nxcheck > 0 & (aform = 2 | cpform = 2)) then;do;nerr = 1;end;
if (nmcheck > 0 & (bform = 2)) then;do;nerr = 1;end;
if (zerr = 0 & nerr = 0 & dmed = 0 & ddv = 0) then;do;mnx=(x1[+]/n); *here we start the main program (1);
   if (xv=9999) then do;tmp=j(n,1,mnx);sdx=sqrt(ssq(x1-tmp)/(n-1));xv=(mnx-sdx)//mnx//(mnx+sdx);end;
   if (aform = 1 & bform = 1 & cpform = 1) then;do;simple = 1;xv=mnx;end;
   indeff=j(btn,nrow(xv),999);
   secheck=j(nrow(xv),1,1);
   ninen=j(nrow(xv),1,999);
   xpnm={"constant"};
   if (cpform = 1) then;do;xpnm = xpnm//{"X"};end;
   if (cpform = 2) then;do;xest1=log(x1);xpnm=xpnm//{"ln(X)"};end;
   if (cpform = 3) then;do;xest1=exp(x1);xpnm=xpnm//{"exp(X)"};end;
   if (cpform = 4) then;do;xest1=x1||x1##2;xpnm=xpnm//{"X", "X*X"};end;
   if (cpform = 5) then;do;xest1=1/x1;xpnm=xpnm//{"1/X"};end;
   xnm={"constant"};
   if (aform = 1) then;do;xnm=xnm//{"X"};end;
   if (aform = 2) then;do;x1=log(x1);xnm=xnm//{"ln(X)"};end;
   if (aform = 3) then;do;x1=exp(x1);xnm=xnm//{"exp(X)"};end;
   if (aform = 4) then;do;x1=x1||x1##2;xnm=xnm//{"X", "X*X"};end;
   if (aform = 5) then;do;x1=1/x1;xnm=xnm//{"1/X"};end;
   if (bform = 1) then;do;xpnm=xpnm//{"M"};end;
   if (bform = 2) then;do;m1=log(m1);xpnm=xpnm//{"ln(M)"};end;
   if (bform = 3) then;do;m1=exp(m1);xpnm=xpnm//{"exp(M)"};end;
   if (bform = 4) then;do;m1=m1||m1##2;xpnm=xpnm//{"M", "M*M"};end;
   if (bform = 5) then;do;m1=1/m1;xpnm=xpnm//{"1/M"};end;
   nmst = nms[1:3,1];
   temp = {"Y", "X", "M"};
   temp = temp||nmst;
   print temp [label=  "VARIABLES IN MEDIATION MODEL"];
   if (ncov > 0) then;do;nmst=nms[4:nrow(nms),1];print nmst [label = "COVARIATES"];end;
   print n [label = "SAMPLE SIZE"];
   print "-------------------------------------------------------------------------";
   do d = 1 to btn;  *here is the opening for the full computational set (2);
      if (d = 1) then;do;x=x1;m=m1;xest=xest1;mo=mo1;mat=con||x;anp=ncol(mat)+1;
      if (ncov > 0) then;do;cov=cov1;covmns=cov[+,]/n;mat=con||x||cov;end;
      y=y1;end;
	  if (d > 1) then;do;v=j(n,1,1);
         do nn = 1 to n;v2=int(ranuni(0)*n)+1;v[nn,1]=v2;end;;
         x=x1[v,];m=m1[v,];mat=con||x;
         if (ncov > 0) then;do;cov=cov1[v,];covmns=cov[+,]/n;mat=con||x||cov;end;        
         xest=xest1[v,];mo=mo1[v,];y=y1[v,];end;
      apaths=inv(mat`*mat)*mat`*mo;
	  if (ncov > 0) then;do;acovpths=apaths[anp:nrow(apaths),1];end;
      if (d = 1) then;do;
      ssresid=ssq(mo-(mat*apaths));msresid=ssresid/(n-ncol(mat));
	  covmat=inv(mat`*mat)*msresid;vara=covmat[2,2];acoeff=apaths[2,1];
	  se=sqrt(vecdiag(covmat));tstat=apaths/se;p=2*(1-probt(abs(tstat),(n-ncol(mat))));
	  outp = apaths||se||tstat||p;
	  sstotal=ssq(mo-(mo[+]/n));r2=1-(ssresid/sstotal);r=sqrt(r2);
      fr=((n-ncol(mat))*r2)/((1-r2)*(ncol(mat)-1));
	  pfr = 1-probf(fr,(ncol(mat)-1),(n-ncol(mat)));
	  if (ncov > 0) then;do;xnm=xnm//nmst;end;
	  cnm = {"Coeff", "SE", "t", "p"};
	  print "MODEL OF M";
      print outp [label = " " colname = cnm rowname = xnm format = 10.4];
	  outp = r||r2||fr||pfr||(ncol(mat)-1)||(n-ncol(mat));
	  cnm = {"R", "R-sq", "F", "p", "df1", "df2"};
	  print outp [label = " " colname = cnm format = 10.4];
	  print "-------------------------------------------------------------------------";
	  end; 
	  mat = con||xest||m;
	  bn=ncol(mat);
	  if (ncov > 0) then;do;mat=con||xest||m||cov;end;
	  bpaths=inv(mat`*mat)*mat`*y;
	  if (d = 1) then;do;
      ssresid=ssq(y-(mat*bpaths));msresid=ssresid/(n-ncol(mat));
	  covmat=inv(mat`*mat)*msresid;varb=covmat[3,3];bcoeff=bpaths[3,1];
	  se=sqrt(vecdiag(covmat));tstat=bpaths/se;p=2*(1-probt(abs(tstat),(n-ncol(mat))));
	  outp = bpaths||se||tstat||p;
	  sstotal=ssq(y-(y[+]/n));r2=1-(ssresid/sstotal);r=sqrt(r2);
      fr=((n-ncol(mat))*r2)/((1-r2)*(ncol(mat)-1));
	  pfr = 1-probf(fr,(ncol(mat)-1),(n-ncol(mat)));
	  if (ncov > 0) then;do;xpnm=xpnm//nmst;end;
	  cnm = {"Coeff", "SE", "t", "p"};
	  print "MODEL OF Y";
      print outp [label = " " colname = cnm rowname = xpnm format = 10.4];
	  outp = r||r2||fr||pfr||(ncol(mat)-1)||(n-ncol(mat));
	  cnm = {"R", "R-sq", "F", "p", "df1", "df2"};
	  print outp [label = " " colname = cnm format = 10.4];
	  print "===========================================================================";
	  end;
	  acovp=0;
	  if (ncov > 0) then;do;acovp=cov1mns*acovpths;end;
      do e = 1 to nrow(xv);  *start of (4);
	    lnerr=0;num=apaths[2,1]*bpaths[bn,1];den=1;
		if (aform=1) then;do;pred=apaths[1,1]+apaths[2,1]*xv[e,1]+acovp; 
          if (bform=2) then;do;num=(apaths[2,1]*bpaths[bn,1]);den=pred;end;
		  if (bform=3) then;do;num=(apaths[2,1]*bpaths[bn,1]*exp(pred));den=1;end;
		  if (bform=4) then;do;num=apaths[2,1]*(bpaths[(bn-1),1]+(2*bpaths[bn,1]*pred));den=1;end;
		  if (bform=5) then;do;num=-(apaths[2,1]*bpaths[bn,1]);den=(pred*pred);end;
        end;
        if (aform=2) then;do;
		  if (xv[e,1] > 0) then;do;pred=apaths[1,1]+apaths[2,1]*log(xv[e,1])+acovp;end;
		  if (xv[e,1] <= 0) then;do;lnerr=1;lnerr2=1;secheck[e,1]=0;pred=1;end;
          if (pred = 0) then;do;lnerr=1;lnerr2=1;secheck[e,1]=0;pred=1;end;
		  if (bform=1) then;do;num=(apaths[2,1]*bpaths[bn,1]);den=xv[e,1];end;
		  if (bform=2) then;do;num=(apaths[2,1]*bpaths[bn,1]);den=pred*xv[e,1];end;
		  if (bform=3) then;do;num=(apaths[2,1]*bpaths[bn,1]*exp(pred));den=xv[e,1];end;
		  if (bform=4) then;do;num=(apaths[2,1]*(bpaths[(bn-1),1]+(2*bpaths[bn,1]*pred)));den=xv[e,1];end;
		  if (bform=5) then;do;num=-(apaths[2,1]*bpaths[bn,1]);den=(pred*pred*xv[e,1]);end;
        end;
        if (aform=3) then;do;
		  pred=apaths[1,1]+apaths[2,1]*exp(xv[e,1])+acovp;
		  if (pred = 0) then;do;lnerr=1;lnerr2=1;secheck[e,1]=0;pred=1;end;
          if (bform=1) then;do;num=apaths[2,1]*bpaths[bn,1]*exp(xv[e,1]);den=1;end;
		  if (bform=2) then;do;num=(apaths[2,1]*bpaths[bn,1]*exp(xv[e,1]));den=pred;end;
          if (bform=3) then;do;num=apaths[2,1]*exp(xv[e,1])*bpaths[bn,1]*exp(pred);den=1;end;
		  if (bform=4) then;do;num=apaths[2,1]*exp(cv[e,1])*(bpaths[(bn-1),1]+(2*bpaths[bn,1]*pred));den=1;end;
		  if (bform=5) then;do;num=-(apaths[2,1]*bpaths[bn,1]*exp(xv[e,1]));den=pred*pred;end;
		end;
		if (aform=4) then;do;
		  pred=apaths[1,1]+apaths[2,1]*xv[e,1]+(apaths[3,1]*xv[e,1]*xv[e,1])+acovp;
		  if (pred = 0) then;do;lnerr=1;lnerr2=1;secheck[e,1]=0;pred=1;end;
	      if (bform=1) then;do;num=(apaths[2,1]+(2*apaths[3,1]*xv[e,1]))*bpaths[bn,1];den=1;end;
		  if (bform=2) then;do;num=((apaths[2,1]+(2*apaths[3,1]*xv[e,1]))*bpaths[bn,1]);den=pred;end;
          if (bform=3) then;do;num=(apaths[2,1]+(2*apaths[3,1]*xv[e,1]))*bpaths[bn,1]*exp(pred);den=1;end;
		  if (bform=4) then;do;num=(apaths[2,1]+(2*apaths[3,1]*xv[e,1]))*(bpaths[(bn-1),1]+(2*bpaths[bn,1]*pred));den=1;end;
		  if (bform=5) then;do;num=-((apaths[2,1]+(2*apaths[3,1]*xv[e,1]))*bpaths[bn,1]);den=pred*pred;end;
        end;
		if (aform = 5) then;do;
		  if (xv[e,1] ^= 0) then;do;pred=apaths[1,1]+(apaths[2,1]/xv[e,1])+acovp;end;
		  if (xv[e,1] = 0) then;do;lnerr=1;lnerr2=1;pred=1;secheck[e,1]=0;end;
		  if (pred=0) then;do;lnerr=1;lnerr2=1;secheck[e,1]=0;pred=1;end;
		  if (bform=1) then;do;num=-(apaths[2,1]*bpaths[bn,1]);den=xv[e,1]*xv[e,1];end;
		  if (bform=2) then;do;num=-(apaths[2,1]*bpaths[bn,1]);den=xv[e,1]*xv[e,1]*pred;end;
		  if (bform=3) then;do;num=-(apaths[2,1]*bpaths[bn,1]*exp(pred));den=xv[e,1]*xv[e,1];end;
		  if (bform=4) then;do;num=-(apaths[2,1]*(bpaths[(bn-1),1]+(2*bpaths[bn,1]*pred)));den=xv[e,1]*xv[e,1];end;
		  if (bform=5) then;do;num=(apaths[2,1]*bpaths[bn,1]);den=xv[e,1]*xv[e,1]*pred*pred;end;
        end;
        if (den ^=0 & lnerr = 0) then;indeff[d,e]=num/den;
		else;do;lnerr2=1;secheck[e,1]=0;end;
      end; *(4);
    end; *(2);
  inddat=(indeff[1,])`;
  if (btn > 1) then;do; *(5);
    indeff=indeff[2:btn,];
    mnind =(indeff[+,]/(btn-1))`;xt=indeff-j((btn-1),1)*indeff[:,];cv=(xt`*xt)/(btn-1);
	seind=sqrt(vecdiag(cv));seind=seind#secheck+((1-(secheck))#ninen);
    if (&save = 1) then;do;create mcest from indeff;append from indeff;end;
    nnn=j(1,ncol(indeff),-999999);indeff=nnn//indeff;
    do e = 1 to ncol(indeff);
	  do i = 2 to btn;ix=indeff[i,e];
	    do k = i to 2 by -1;
		    k2 = k;
		    if (indeff[(k-1),e] > ix) then;
            do;
            indeff[k,e]=indeff[(k-1),e];
            end;
			else;  
              if (indeff[(k-1),e] <= ix) then;
              do;   
              goto stpit;
              end;
		    end;
		  stpit:
		  indeff[k2,e]=ix;
	  end;
	end;
	indeff=indeff[2:btn,];
    zst=j(1,nrow(xv),1);
    zprop=zst;
	if (&percent ^= 0) then;do;
	  lowalp=0.5*(1-(conf/100))*zst;
      upalp=0.5*(1+(conf/100))*zst;
      p=lowalp;y5=sqrt(-2*log(p));xp=y5;
      do f = 1 to ncol(y5);
        y5t=y5[1,f];
        xp[1,f]=y5t+((((y5t*p4+p3)*y5t+p2)*y5t+p1)*y5t+p0)/((((y5t*q4+q3)*y5t+q2)*y5t+q1)*y5t+q0);
        end;
	 end;
     if (&percent ^= 1) then;do;
	   do f = 1 to nrow(xv);bcd=(indeff[,f] < inddat[f,1]);bcd=bcd[+];zprop[1,f]=bcd/(btn-1);end;
       p=0.5*(1-(conf/100));y5=sqrt(-2*log(p));
       xp=y5+((((y5*p4+p3)*y5+p2)*y5+p1)*y5+p0)/((((y5*q4+q3)*y5+q2)*y5+q1)*y5+q0);
       lowza=-xp*zst;highza=xp*zst;
	   do f = 1 to nrow(xv);pv=zprop[1,f];p=pv;
		 if (pv > .5) then;do;p=1-pv;end;
		 y5=sqrt(-2*log(p));
         xp=y5+((((y5*p4+p3)*y5+p2)*y5+p1)*y5+p0)/((((y5*q4+q3)*y5+q2)*y5+q1)*y5+q0);
         if (pv <= .5) then;do;xp=-xp;end;
		 zprop[1,f]=xp;
	   end;
	   bczlow=(2*zprop)+lowza;bczhi=(2*zprop)+highza;lowalp=probnorm(bczlow);upalp=probnorm(bczhi);   
	   end;
	 blow=int(lowalp*((btn-1)));bhigh=int(upalp*((btn-1))+1);
	 bllci=j(ncol(blow),1,1);bulci=bllci;
     do f = 1 to ncol(blow);
	   if (blow[1,f] < 1) then;do;blow[1,f]=1;end;
	   if (bhigh[1,f] > (btn-1)) then;do;bhigh[1,f]=(btn-1);end;
	   bllci[f,1]=indeff[blow[1,f],f];bulci[f,1]=indeff[bhigh[1,f],f];
	 end;
  end; *end (5);
if (simple = 1) then;do;inddat1=inddat[1,1];
  seind1=sqrt((acoeff*acoeff*varb)+(bcoeff*bcoeff*vara)+(vara*varb));
  z1=inddat1/seind1;
  p1=2*(1-probnorm(abs(z1)));
  llci95=inddat1-xp2*seind1;
  ulci95=inddat1+xp2*seind1;
  outp=inddat1||seind1||llci95||ulci95||z1||p1;
  cnm = {"Value", "SE", "LowerCI", "UpperCI", "Z", "P"};
  print "INDIRECT EFFECT AND SIGNIFICANCE USING NORMAL DISTRIBUTION";
  print outp [label = " " colname = cnm rowname = " " format = 10.4];  
end;
if ((btn > 1) & (simple = 0)) then;do;
  outp=xv||inddat||seind;
  cnm = {"XVAL", "THETA", "SE"};
  print "Instantaneous Indirect Effect (THETA) of X on Y through M at X = XVAL";
  print outp [label = " " colname = cnm rowname = " " format = 10.4];
end;
if (simple = 0 & btn > 1) then;do;
  outp = xv||bllci||inddat||bulci;
  if (&percent = 1) then;do;
    print "Percentile Bootstrap Confidence Interval for Instantaneous Indirect Effect";
	cnm = {"XVAL", "LowerCI", "THETA", "UpperCI"};
	print outp [label = " " colname = cnm rowname = " " format = 10.4];
    end;
  if (&percent ^= 1) then;do;
    print "Bias Corrected Bootstrap Confidence Interval for Instantaneous Indirect Effect";
	cnm = {"XVAL", "LowerCI", "THETA", "UpperCI"};
	print outp [label = " " colname = cnm rowname = " " format = 10.4];
    end;
  bb=btn-1;
  print bb [label = "BOOTSTRAP SAMPLES:" format = 10.0];
end;
if ((simple = 1) & (btn > 1)) then;do;
  outp = bllci||inddat1||bulci;
  if (&percent = 1) then;do;
    print "Percentile Bootstrap Confidence Interval for Indirect Effect";
	cnm = {"LowerCI", "Point", "UpperCI"};
	print outp [label = " " colname = cnm rowname = " " format = 10.4];
	end;
  if (&percent ^= 1) then;do;
    print "Bias Corrected Bootstrap Confidence Interval for Indirect Effect";
	cnm = {"LowerCI", "Point", "UpperCI"};
	print outp [label = " " colname = cnm rowname = " " format = 10.4];
	end;
  bb=btn-1;
  print bb [label = "BOOTSTRAP SAMPLES:" format = 10.0];
end;
if ((btn = 1) & (simple = 0)) then; do;
  outp = xv||inddat;
  print "Instantaneous Indirect Effect (THETA) of X on Y thorugh M at X = XVAL";
  cnm = {"XVAL", "THETA"};
  print outp [label = " " colname = cnm rowname = " " format = 10.4];
end;
print "-------------------------------------------------------------------------";
print "NOTES:";
if ((btn > 1) | (simple = 1)) then;do;
  print conf [label = "LEVEL OF CONFIDENCE FOR CONFIDENCE INTERVALS:"];end;
tpp = (xv < xmin);tpp=tpp[+];
tpq = (xv > xmax);tpq=tpq[+];
if ((tpp > 0) | (tpq > 0)) then;do;
  print "EXTRAPOLATION WARNING: One or more XVAL values above is beyond the range of the data.";end;
if ((nrow(xv) = 3) & (simple = 0)) then;do;
  print "XVAL values above are the sample mean and plus/minus one SD from mean.";end;
if ((btn > 1) & (simple = 0)) then;do;
  print "SE for THETA is the standard deviation of the bootstrap estimates.";end;
if (simple = 1) then;do;
  print "SE for indirect effect is the second order delta (Aroian, 1944/Sobel, 1982) estimate.";end;
if ((simple = 0) & (btn < 1000)) then;do;
  print "For inferential statistics for THETA, request bootstrapping.";end;
if (lnerr2 = 1) then;do;
  print "999.0000 = Indirect effect not defined for specified XVAL or during bootstrapping.";end;
end;
if (zerr = 1) then;do;print "Zeros in the data prevent a log or inverse model from being estimated.";end;
if (nerr = 1) then;do;print "Negatives in the data prevent a log model from being estimated.";end;
if (dindep=1) then;do;print "X is a dichotomous variable. Its effect on M and Y is set to linear.";end;
if (dindep=1) then;do;print "There is only a single interpretable indirect effect. That indirect effect is provided above";end;
if (dmed = 1) then;do;print "M is a dichotomous variable. This procedure is not appropriate.";end;
if (ddv = 1) then;do;print "Y is a dichotomous variable. This procedure is not appropriate.";end;
if (simple = 1) then;do;print "All effects are specified as linear, so the indirect effect is constant."; end;
quit;
%mend;
