﻿* Encoding: UTF-8.
/* MEDCURVE macro for SPSS */.
/* Written by Andrew F Hayes */.
/* Haskayne School of Business */.
/* University of Calgary */.
/* Written 21 March 2010 */.


DEFINE MEDCURVE (y = !charend('/')/x = !charend('/')/m = !charend('/')
  /aform = !charend('/') !default(1)/bform = !charend('/') !default(1)
  /cpform = !charend('/') !default(1)/boot = !charend('/') !default(0)
  /xval = !charend('/') !default(9999)/conf = !charend('/') !default(95)/
  percent = !charend ('/') !default(0)/save = !charend('/') !default(0)).
set mxloops = 10000000.
set printback = off.
MATRIX.
get dd/variables = !y !x !m/names = nms/MISSING = OMIT.
compute n = nrow(dd).
compute y1 = dd(:,1).
compute m1 = dd(:,3).
compute mo1 = m1.
compute ncov = ncol(dd)-3.
compute x1 = dd(:,2).
compute xest1 = x1.
compute xv = !xval.
compute con=make(n,1,1).
do if (ncov > 0).
compute cov1 = dd(:,4:ncol(dd)).
compute cov1mns=csum(cov1/n).
end if.
compute simple = 0.
compute zerr = 0.
compute nerr = 0.
compute lnerr2 = 0.
compute dindep = 0.
compute dmed = 0.
compute ddv = 0.
compute xmax = cmax(x1).
compute xmin = cmin(x1).
compute aform = !aform.
compute cpform = !cpform.
compute zxcheck = csum(x1 = 0).
compute zmcheck = csum(mo1 = 0).
compute nxcheck = csum(x1 < 0).
compute nmcheck = csum(mo1 < 0).
compute tmp = ncol(design(x1)).
do if (tmp = 2).
  compute dindep = 1.
  compute aform = 1.
  compute cpform = 1.
  compute xv = xmin.
  compute zxcheck=0.
  compute nxcheck=0.
end if.
compute tmp2 = ncol(design(m1)).
do if (tmp2 = 2).
  compute dmed = 1.
end if.
compute tmp3 = ncol(design(y1)).
do if (tmp3 = 2).
  compute ddv = 1.
end if.
compute conf = !conf.
compute p0= -.322232431088.
compute p1 = -1.
compute p2 = -.342242088547.
compute p3 = -.0204231210245.
compute p4 = -.0000453642210148.
compute q0 = .0993484626060.
compute q1 = .588581570495.
compute q2 = .531103462366.
compute q3 = .103537752850.
compute q4 = .0038560700634.
do if (conf < 50 or conf > 99).
compute conf = 95.
end if.
compute p = 0.5*(1-(conf/100)).
compute y5=sqrt(-2*ln(p)).
compute xp=y5+((((y5*p4+p3)*y5+p2)*y5+p1)*y5+p0)/((((y5*q4+q3)*y5+q2)*y5+q1)*y5+q0).
compute xp2=xp.
do if (!boot > 999).
  compute btn = (trunc(!boot/1000)*1000)+1.
  else.
  compute btn = 1.
end if.
do if (zxcheck > 0 and (aform = 2 or aform = 5 or cpform = 2 or cpform = 5)).
  compute zerr = 1.
end if.
do if (zmcheck > 0 and (!bform = 2 or !bform = 5)).
  compute zerr = 1.
end if.
do if (nxcheck > 0 and (aform = 2 or cpform = 2)).
  compute nerr = 1.
end if.
do if (nmcheck > 0 and (!bform = 2)).
  compute nerr = 1.
end if.
do if (zerr = 0 and nerr = 0 and dmed = 0 and ddv = 0).
  compute mnx = csum(x1)/n.
do if (xv = 9999).
  compute tmp = make(n,1,mnx).
  compute sdx = sqrt(csum(((x1-tmp)&**2))/(n-1)).
  compute xv = {mnx-sdx; mnx; mnx+sdx}.
end if.
do if (aform = 1 and !bform = 1 and cpform = 1).
  compute simple = 1.
  compute xv = mnx.
end if.
compute indeff = make(btn,nrow(xv),999).
compute secheck = make(nrow(xv),1,1).
compute ninen = make(nrow(xv),1,999).
compute xpnm = {"constant"}.
do if (cpform = 1).
  compute xpnm = {xpnm, "X"}.
  else if (cpform = 2).
    compute xest1 = ln(x1).
    compute xpnm = {xpnm, "ln(X)"}.
  else if (cpform = 3).
    compute xest1 = exp(x1).
    compute xpnm = {xpnm, "exp(X)"}.
  else if (cpform = 4).
    compute xest1 = {x1, x1&*x1}.
    compute xpnm = {xpnm, "X", "X*X"}.
  else if (cpform = 5).
    compute xest1 = 1/x1.
    compute xpnm = {xpnm, "1/X"}.
end if.
compute xnm = {"constant"}.
do if (aform = 1).
  compute xnm = {xnm, "X"}.
  else if (aform = 2).
    compute x1 = ln(x1).
    compute xnm = {xnm, "ln(X)"}.
  else if (aform = 3).
    compute x1 = exp(x1).
    compute xnm = {xnm, "exp(X)"}.
  else if (aform = 4).
    compute x21 = x1&*x1.
    compute x1 = {x1,x21}.
    compute xnm = {xnm, "X", "X*X"}.
  else if (aform = 5).
    compute x1 = 1/x1.
    compute xnm = {xnm, "1/X"}.
end if.
do if (!bform = 1).
  compute xpnm = {xpnm, "M"}.
  else if (!bform = 2).
    compute m1 = ln(m1).
    compute xpnm = {xpnm, "ln(M)"}.
  else if (!bform = 3).
    compute m1 = exp(m1).
    compute xpnm = {xpnm, "exp(M)"}.
  else if (!bform = 4).
    compute m21 = m1&*m1.
    compute m1 = {m1,m21}.
    compute xpnm = {xpnm, "M", "M*M"}.
  else if (!bform = 5).
    compute m1 = 1/m1.
    compute xpnm = {xpnm, "1/M"}.
end if.
compute nmst = nms(1,1:3)).
compute temp = {"Y"; "X"; "M"}.
compute temp = {temp, t(nmst)}.
print temp/title = "VARIABLES IN MEDIATION MODEL"/format = A8.
do if (ncov > 0).
compute nmst = t(nms(1,4:ncol(nms))).
print nmst/title = "COVARIATES"/format = A8.
end if.
print n/title = "SAMPLE SIZE"/format = F10.0.
print/title = "----------------------------------------------------------------".
loop #d = 1 to btn.
do if (#d = 1).
compute x = x1.
compute m = m1.
compute xest = xest1.
compute mo = mo1.
compute  mat = {con,x}.
compute anp = ncol(mat)+1.
do if (ncov > 0).
compute cov = cov1.
compute covmns = csum(cov)/n.
compute  mat = {con,x,cov}.
end if.
compute y=y1.
else if (#d > 1).
compute v=trunc(uniform(n,1)*n)+1.
compute x(:,:) = x1(v,:).
compute m(:,:) = m1(v,:).
compute  mat = {con,x}.
do if (ncov > 0).
compute cov(:,:)=cov1(v,:).
compute covmns = csum(cov)/n.
compute mat = {con,x,cov}.
end if.
compute xest(:,:) = xest1(v,:).
compute mo(:,:)=mo1(v,:).
compute y(:,:)=y1(v,:).
end if.
compute apaths = inv(t(mat)*mat)*t(mat)*mo.
do if (ncov > 0).
compute acovpths = apaths(anp:nrow(apaths),1).
end if.
do if (#d = 1).
compute ssresid = (csum((mo-(mat*apaths))&**2)).
compute msresid = ssresid/(n-ncol(mat)).
compute covmat = inv(t(mat)*mat)*msresid.
compute vara = covmat(2,2).
compute acoeff = apaths(2,1).
compute se = sqrt(diag(covmat)).
compute tstat = apaths&/se.
compute p = 2*(1-tcdf(abs(tstat),n-ncol(mat)))).
compute outp = {apaths, se, tstat, p}.
compute sstotal = csum((mo-(csum(mo)/n))&**2).
compute r2 = 1-(ssresid/sstotal).
compute r = sqrt(r2).
compute fr = ((n-ncol(mat))*r2)/((1-r2)*(ncol(mat)-1)).
compute pfr = 1-fcdf(fr,(ncol(mat)-1),(n-ncol(mat))).
do if (ncov > 0).
compute xnm = {t(xnm);nmst}.
end if.
print outp/TITLE = "MODEL OF M"/clabels = "Coeff" "SE" "t" "p"/
  rnames = xnm/format F10.4.
compute outp = {r, r2, fr, pfr, (ncol(mat)-1), (n-ncol(mat))}.
print outp/TITLE = "MODEL SUMMARY"/clabels = "R" "R-sq" "F" "p" "df1" "df2"/format F10.4.
print/title = "----------------------------------------------------------------".
end if.
compute mat = {con,xest,m}.
compute bn = ncol(mat).
do if (ncov > 0).
compute mat = {con,xest,m,cov}.
end if.
compute bpaths = inv(t(mat)*mat)*t(mat)*y.
do if (#d = 1).
compute ssresid = (csum((y-(mat*bpaths))&**2)).
compute msresid = ssresid/(n-ncol(mat)).
compute covmat = inv(t(mat)*mat)*msresid.
compute varb = covmat(3,3).
compute bcoeff = bpaths(3,1).
compute se = sqrt(diag(covmat)).
compute outp = {bpaths, se}.
compute tstat = bpaths&/se.
compute p = 2*(1-tcdf(abs(tstat),n-ncol(mat)))).
compute outp = {bpaths, se, tstat, p}.
compute sstotal = csum((y-(csum(y)/n))&**2).
compute r2 = 1-(ssresid/sstotal).
compute r = sqrt(r2).
compute fr = ((n-ncol(mat))*r2)/((1-r2)*(ncol(mat)-1)).
compute pfr = 1-fcdf(fr,(ncol(mat)-1),(n-ncol(mat))).
do if (ncov > 0).
compute xpnm = {t(xpnm);nmst}.
end if.
print outp/TITLE = "MODEL OF Y"/clabels = "Coeff" "SE" "t" "p"/
  rnames = xpnm/format F10.4.
compute outp = {r, r2, fr, pfr, (ncol(mat)-1), (n-ncol(mat))}.
print outp/TITLE = "MODEL SUMMARY"/clabels = "R" "R-sq" "F" "p" "df1" "df2"/format F10.4.
print/title = "----------------------------------------------------------------".
end if.
compute acovp = 0.
do if (ncov > 0).
compute acovp=cov1mns*acovpths.
end if.
loop #e = 1 to nrow(xv).
compute lnerr = 0.
compute num = apaths(2,1)*bpaths(bn,1).
compute den = 1.
do if (aform = 1).
compute pred = apaths(1,1)+apaths(2,1)*xv(#e,1)+acovp.
do if (!bform = 2).
compute num = (apaths(2,1)*bpaths(bn,1)).
compute den = pred.
else if (!bform = 3).
compute num = apaths(2,1)*bpaths(bn,1)*exp(pred).
compute den = 1.
else if (!bform = 4).
compute num = apaths(2,1)*(bpaths((bn-1),1)+(2*bpaths(bn,1)*pred)).
compute den = 1.
else if (!bform = 5).
compute num = -(apaths(2,1)*bpaths(bn,1)).
compute den = (pred*pred).
end if.
end if.
do if (aform = 2).
do if (xv(#e,1) > 0).
compute pred = apaths(1,1)+apaths(2,1)*ln(xv(#e,1))+acovp.
else.
compute lnerr = 1.
compute lnerr2 = 1.
compute secheck(#e,1)=0.
compute pred = 1.
end if.
do if (pred = 0).
compute lnerr = 1.
compute lnerr2 = 1.
compute secheck(#e,1)=0.
compute pred = 1.
end if.
do if (!bform = 1).
compute num = (apaths(2,1)*bpaths(bn,1)).
compute den = xv(#e,1).
else if (!bform = 2).
compute num = (apaths(2,1)*bpaths(bn,1)).
compute den = (pred*xv(#e,1)).
else if (!bform = 3).
compute num = (apaths(2,1)*bpaths(bn,1)*exp(pred)).
compute den = xv(#e,1).
else if (!bform = 4).
compute num = (apaths(2,1)*(bpaths((bn-1),1)+(2*bpaths(bn,1)*pred))).
compute den = xv(#e,1).
else if (!bform = 5).
compute num = -(apaths(2,1)*bpaths(bn,1)).
compute den = (pred*pred*xv(#e,1)). 
end if.
end if.
do if (aform = 3).
compute pred = apaths(1,1)+apaths(2,1)*exp(xv(#e,1))+acovp.
do if (pred = 0).
compute lnerr = 1.
compute lnerr2 = 1.
compute secheck(#e,1)=0.
compute pred = 1.
end if.
do if (!bform = 1).
compute num = apaths(2,1)*bpaths(bn,1)*exp(xv(#e,1)).
compute den = 1.
else if (!bform = 2).
compute num = (apaths(2,1)*bpaths(bn,1)*exp(xv(#e,1))).
compute den = pred.
else if (!bform = 3).
compute num = apaths(2,1)*exp(xv(#e,1))*bpaths(bn,1)*exp(pred).
compute den = 1.
else if (!bform = 4).
compute num = apaths(2,1)*exp(xv(#e,1))*(bpaths((bn-1),1)+(2*bpaths(bn,1)*pred)).
compute den = 1.
else if (!bform = 5).
compute num = -(apaths(2,1)*bpaths(bn,1)*exp(xv(#e,1))).
compute den = pred*pred.
end if.
end if.
do if (aform = 4).
compute pred = apaths(1,1)+apaths(2,1)*xv(#e,1)+(apaths(3,1)*xv(#e,1)*xv(#e,1))+acovp.
do if (pred = 0).
compute lnerr = 1.
compute lnerr2 = 1.
compute secheck(#e,1)=0.
compute pred = 1.
end if.
do if (!bform = 1).
compute num = (apaths(2,1)+(2*apaths(3,1)*xv(#e,1)))*bpaths(bn,1).
compute den = 1.
else if (!bform = 2).
compute num = ((apaths(2,1)+(2*apaths(3,1)*xv(#e,1)))*bpaths(bn,1)).
compute den = pred.
else if (!bform = 3).
compute num = (apaths(2,1)+(2*apaths(3,1)*xv(#e,1)))*bpaths(bn,1)*exp(pred).
compute den = 1.
else if (!bform = 4).
compute num = (apaths(2,1)+(2*apaths(3,1)*xv(#e,1)))*(bpaths((bn-1),1)+(2*bpaths(bn,1)*pred)).
compute den = 1.
else if (!bform = 5).
compute num =  -((apaths(2,1)+(2*apaths(3,1)*xv(#e,1)))*bpaths(bn,1)).
compute den = pred*pred.
end if.
end if.
do if (aform = 5).
do if (xv(#e,1) <> 0).
compute pred = apaths(1,1)+(apaths(2,1)/xv(#e,1))+acovp.
else.
compute lnerr = 1.
compute lnerr2 = 1.
compute pred = 1.
compute secheck(#e,1)=0.
end if.
do if (pred = 0).
compute lnerr = 1.
compute lnerr2 = 1.
compute secheck(#e,1)=0.
compute pred = 1.
end if.
do if (!bform = 1).
compute num = -(apaths(2,1)*bpaths(bn,1)).
compute den = xv(#e,1)*xv(#e,1)).
else if (!bform = 2).
compute num = -(apaths(2,1)*bpaths(bn,1)).
compute den = (xv(#e,1)*xv(#e,1)*pred).
else if (!bform = 3).
compute num =  -(apaths(2,1)*bpaths(bn,1)*exp(pred)).
compute den = (xv(#e,1)*xv(#e,1)).
else if (!bform = 4).
compute num = -(apaths(2,1)*(bpaths((bn-1),1)+(2*bpaths(bn,1)*pred))).
compute den = (xv(#e,1)*xv(#e,1)). 
else if (!bform = 5).
compute num = (apaths(2,1)*bpaths(bn,1)).
compute den = (xv(#e,1)*xv(#e,1)*pred*pred).
end if.
end if.
do if (den <> 0 and lnerr = 0).
compute indeff(#d, #e) = num/den.
else.
compute lnerr2 = 1.
compute secheck(#e,1)=0.
end if.
end loop.
end loop.
compute inddat = t(indeff(1,:)).
do if (btn > 1).
compute indeff = indeff(2:(btn),:).
compute seind = t(sqrt((((btn-1)*cssq(indeff))-(csum(indeff)&**2))/((btn-2)*(btn-1)))).
compute seind = seind&*secheck+((1-(secheck))&*ninen).
do if (!save = 1).
save indeff/outfile = *.
end if.
compute nnn = make(1,ncol(indeff),-999999).
compute indeff = {nnn;indeff}.
loop #e = 1 to ncol(indeff).
  loop #i = 2 to (btn).
  compute ix = indeff(#i,#e).
     loop #k= #i to 2 by -1.
       compute k = #k.
       do if (indeff(#k-1,#e) > ix).
         compute indeff(#k,#e)=indeff(#k-1,#e).
         else if (indeff(#k-1,#e) <= ix).
           BREAK.
       end if.
     end loop.
     compute indeff(k,#e)=ix.
  end loop.
end loop.
compute indeff = indeff(2:btn,:).
compute zst = make(1,nrow(xv),1).
compute zprop = zst.


do if (!percent <> 0).
compute lowalp = 0.5*(1-(conf/100))*zst.
compute upalp = 0.5*(1+(conf/100))*zst.
compute p = lowalp.
compute y5=sqrt(-2*ln(p)).
compute xp = y5.
loop #f = 1 to ncol(y5).
  compute y5t = y5(1,#f).
  compute xp(1,#f)=y5t+((((y5t*p4+p3)*y5t+p2)*y5t+p1)*y5t+p0)/((((y5t*q4+q3)*y5t+q2)*y5t+q1)*y5t+q0).
end loop.
else.
loop #f = 1 to nrow(xv).
compute zprop(1,#f)=(csum(indeff(:,#f )< inddat(#f,1)))/(btn-1).
end loop.
compute p = 0.5*(1-(conf/100)).
  compute y5=sqrt(-2*ln(p)).
  compute xp=(y5+((((y5*p4+p3)*y5+p2)*y5+p1)*y5+p0)/((((y5*q4+q3)*y5+q2)*y5+q1)*y5+q0)).
  compute lowza =  -xp*zst.
  compute highza = xp*zst.
  loop #f = 1 to nrow(xv).
  compute pv = zprop(1,#f).
  compute p = pv.
  do if (pv > .5).
    compute p = 1-pv.
  end if.
  compute y5=sqrt(-2*ln(p)).
  compute xp=y5+((((y5*p4+p3)*y5+p2)*y5+p1)*y5+p0)/((((y5*q4+q3)*y5+q2)*y5+q1)*y5+q0).
  do if (pv <= .5).
    compute xp = -xp.
  end if.
  compute zprop(1,#f) = xp.
  end loop.
  compute bczlow = (2*zprop)+lowza.
  compute bczhi = (2*zprop)+highza.
  compute lowalp=cdfnorm(bczlow).
  compute upalp = cdfnorm(bczhi).
end if.
compute blow = trunc(lowalp*((btn-1))).
compute bhigh = trunc(upalp*((btn-1))+1).
compute bllci = make(ncol(blow),1,1).
compute bulci = bllci.
loop #f = 1 to ncol(blow).
do if (blow(1,#f) < 1).
  compute blow(1,#f) = 1.
end if.
do if (bhigh(1,#f) > (btn-1)).
  compute bhigh(1,#f) = (btn-1).
end if.
compute bllci(#f,1)=indeff(blow(1,#f),#f).
compute bulci(#f,1)=indeff(bhigh(1,#f),#f).
end loop.
end if.
do if (simple = 1).
compute inddat1 = inddat(1,1).
compute seind1 = sqrt((acoeff*acoeff*varb)+(bcoeff*bcoeff*vara)+(vara*varb)).
compute z1 = inddat1/seind1.
compute p1 = 2*(1-cdfnorm(abs(z1))).
compute LLCI95 = inddat1-xp2*seind1.
compute ULCI95 = inddat1+xp2*seind1.
compute outp = {inddat1, seind1, LLCI95, ULCI95, z1, p1}.
print outp/title = "INDIRECT EFFECT AND SIGNIFICANCE USING NORMAL DISTRIBUTION"/clabels "Value" "se" "LowerCI" "UpperCI" "Z" "p"/format F10.4.
end if.
do if (btn > 1 and simple = 0).
compute outp = {xv, inddat, seind}.
print outp/title = "Instantaneous Indirect Effect (THETA) of X on Y through M at X = XVAL"/
  clabels = "XVAL" "THETA" "SE" "Z"/format F8.4.
end if.
do if (simple = 0 and btn > 1).
compute outp = {XV, BLLCI, INDDAT, BULCI}.
do if (!percent = 1).
print outp/title = "Percentile Bootstrap Confidence Interval for Instantaneous Indirect Effect"/
  clabels = "XVAL" "LowerCI" "THETA" "UpperCI"/format F8.4.
else.
print outp/title = "Bias Corrected Bootstrap Confidence Interval for Instantaneous Indirect Effect"/
  clabels = "XVAL" "LowerCI" "THETA" "UpperCI"/format F8.4.
end if.
compute bb = btn-1.
print bb/title = "BOOTSTRAP SAMPLES:"/format F10.0.
end if.
do if (simple = 1 and btn > 1).
compute outp = {BLLCI, INDDAT1, BULCI}.
do if (!percent = 1).
print outp/title = "Percentile Bootstrap Confidence Interval for Indirect Effect"/
  clabels = "LowerCI" "Point" "UpperCI"/format F8.4.
else.
print outp/title = "Bias Corrected Bootstrap Confidence Interval for Indirect Effect"/
  clabels = "LowerCI" "Point" "UpperCI"/format F8.4.
end  if.
compute bb = btn-1.
print bb/title = "BOOTSTRAP SAMPLES:"/format F10.0.
end if.
do if (btn = 1 and simple = 0).
compute outp = {xv, inddat}.
print outp/title = "Instantaneous Indirect Effect (THETA) of X on Y through M at X = XVAL"/clabels = "XVAL" "THETA"/format F8.4.
end if.
print/title = "-----------------------------------------------------------------".
print/title = "NOTES:".
do if (btn > 1 or simple = 1).
print conf/title = "LEVEL OF CONFIDENCE FOR CONFIDENCE INTERVALS:".
end if.
do if ((csum(xv < xmin) > 0) or (csum(xv > xmax) > 0)).
print/title = "EXTRAPOLATION WARNING: One or more XVAL values above is beyond the range of the data.".
end if.
do if (nrow(xv) = 3) and simple = 0).
print/title = "XVAL values above are the sample mean and plus/minus one SD from mean".
end if.
do if (btn > 1 and simple = 0).
print/title = "SE for THETA is the standard deviation of the bootstrap estimates".
end if.
do if (simple = 1).
print/title = "SE for indirect effect is the second order delta (Aroian, 1944/Sobel, 1982) estimate.".
end if.
do if (simple = 0 and btn < 1000).
print/title = "For inferential statistics for THETA, request bootstrapping".
end if.
do if (lnerr2 = 1).
print/title = "999.0000 = Indirect effect not defined for specified XVAL or during bootstrapping".
end if.
end if.
do if (zerr = 1).
print/title = "Zeros in the data prevent a log or inverse model from being estimated.".
end if.
do if (nerr = 1).
print/title = "Negatives in the data prevent a log model from being estimated.".
end if.
do if (dindep = 1).
print/title = "X is a dichotomous variable.  It's effect on M and Y is set to linear".
print/title = "There is only a single interpretable indirect effect.  That indirect effect is provided above".
end if.
do if (dmed = 1).
print/title = "M is a dichotomous variable.  This procedure is not appropriate.".
end if.
do if (ddv = 1).
print/title = "Y is a dichotomous variable.  This procedure is not appropriate.".
end if.
do if (simple = 1).
print/title = "All effects are specified as linear, so the indirect effect is constant.".
end if.
END MATRIX.
!ENDDEFINE.

